program MyCompiler;
uses Windows, Messages, SysUtils, Classes, Dialogs, shellapi, Math
, RegExpr in 'C:\Programme\AtoCC\Temp\RegExpr.pas';
///////////////////////////////////////////////////////////
/// Global settings: 
///////////////////////////////////////////////////////////
var x : Integer = 10;
var cy : Integer = 0;

///////////////////////////////////////////////////////////


(* global definitions: *)

type TOutput = class
     public
      Text : String;
      procedure WriteLine(s : String);
      constructor Create();
     end;

constructor TOutput.Create;
begin Text := ''; end;

procedure TOutput.WriteLine(S : String);
begin Text := Text + s; end;

var Output : TOutput;

const t_Unterstrich = 257;
const t_T_8 = 258;
const t_T_16 = 259;
const t_T_32 = 260;
const t_T_1 = 261;
const t_T_2 = 262;
const t_T_4 = 263;
const t_T_0 = 264;
const t_G = 265;
const t_A = 266;
const t_H = 267;
const t_F = 268;
const t_C = 269;
const t_D = 270;
const t_E = 271;
const t_ignore = 256;
////////////////////////////////////////////////////////////////
/// Scanner
////////////////////////////////////////////////////////////////

type  AToken = record
	token : Integer;
	val   : String;
      end;

var TokenList : Array of AToken;

function FindToken (Rest : String) : AToken;
var r : TRegExpr; Results : Array of Integer; ResultsV : Array of String;
var maxlength,besttoken,i : Integer;
begin
   r := TRegExpr.Create;
   r.Expression := '^(_)';
	if r.Exec (Rest) then begin
       SetLength(Results,high(Results)+2);
       SetLength(ResultsV,high(ResultsV)+2);
       Results[high(ResultsV)]  := t_Unterstrich;
	    ResultsV[high(ResultsV)] := r.Match [0];
	end;
             
   r.Expression := '^(8)';
	if r.Exec (Rest) then begin
       SetLength(Results,high(Results)+2);
       SetLength(ResultsV,high(ResultsV)+2);
       Results[high(ResultsV)]  := t_T_8;
	    ResultsV[high(ResultsV)] := r.Match [0];
	end;
             
   r.Expression := '^(16)';
	if r.Exec (Rest) then begin
       SetLength(Results,high(Results)+2);
       SetLength(ResultsV,high(ResultsV)+2);
       Results[high(ResultsV)]  := t_T_16;
	    ResultsV[high(ResultsV)] := r.Match [0];
	end;
             
   r.Expression := '^(32)';
	if r.Exec (Rest) then begin
       SetLength(Results,high(Results)+2);
       SetLength(ResultsV,high(ResultsV)+2);
       Results[high(ResultsV)]  := t_T_32;
	    ResultsV[high(ResultsV)] := r.Match [0];
	end;
             
   r.Expression := '^(1)';
	if r.Exec (Rest) then begin
       SetLength(Results,high(Results)+2);
       SetLength(ResultsV,high(ResultsV)+2);
       Results[high(ResultsV)]  := t_T_1;
	    ResultsV[high(ResultsV)] := r.Match [0];
	end;
             
   r.Expression := '^(2)';
	if r.Exec (Rest) then begin
       SetLength(Results,high(Results)+2);
       SetLength(ResultsV,high(ResultsV)+2);
       Results[high(ResultsV)]  := t_T_2;
	    ResultsV[high(ResultsV)] := r.Match [0];
	end;
             
   r.Expression := '^(4)';
	if r.Exec (Rest) then begin
       SetLength(Results,high(Results)+2);
       SetLength(ResultsV,high(ResultsV)+2);
       Results[high(ResultsV)]  := t_T_4;
	    ResultsV[high(ResultsV)] := r.Match [0];
	end;
             
   r.Expression := '^(0)';
	if r.Exec (Rest) then begin
       SetLength(Results,high(Results)+2);
       SetLength(ResultsV,high(ResultsV)+2);
       Results[high(ResultsV)]  := t_T_0;
	    ResultsV[high(ResultsV)] := r.Match [0];
	end;
             
   r.Expression := '^(G)';
	if r.Exec (Rest) then begin
       SetLength(Results,high(Results)+2);
       SetLength(ResultsV,high(ResultsV)+2);
       Results[high(ResultsV)]  := t_G;
	    ResultsV[high(ResultsV)] := r.Match [0];
	end;
             
   r.Expression := '^(A)';
	if r.Exec (Rest) then begin
       SetLength(Results,high(Results)+2);
       SetLength(ResultsV,high(ResultsV)+2);
       Results[high(ResultsV)]  := t_A;
	    ResultsV[high(ResultsV)] := r.Match [0];
	end;
             
   r.Expression := '^(H)';
	if r.Exec (Rest) then begin
       SetLength(Results,high(Results)+2);
       SetLength(ResultsV,high(ResultsV)+2);
       Results[high(ResultsV)]  := t_H;
	    ResultsV[high(ResultsV)] := r.Match [0];
	end;
             
   r.Expression := '^(F)';
	if r.Exec (Rest) then begin
       SetLength(Results,high(Results)+2);
       SetLength(ResultsV,high(ResultsV)+2);
       Results[high(ResultsV)]  := t_F;
	    ResultsV[high(ResultsV)] := r.Match [0];
	end;
             
   r.Expression := '^(C)';
	if r.Exec (Rest) then begin
       SetLength(Results,high(Results)+2);
       SetLength(ResultsV,high(ResultsV)+2);
       Results[high(ResultsV)]  := t_C;
	    ResultsV[high(ResultsV)] := r.Match [0];
	end;
             
   r.Expression := '^(D)';
	if r.Exec (Rest) then begin
       SetLength(Results,high(Results)+2);
       SetLength(ResultsV,high(ResultsV)+2);
       Results[high(ResultsV)]  := t_D;
	    ResultsV[high(ResultsV)] := r.Match [0];
	end;
             
   r.Expression := '^(E)';
	if r.Exec (Rest) then begin
       SetLength(Results,high(Results)+2);
       SetLength(ResultsV,high(ResultsV)+2);
       Results[high(ResultsV)]  := t_E;
	    ResultsV[high(ResultsV)] := r.Match [0];
	end;
             
   r.Expression := '^([\r\n\t\s])';
	if r.Exec (Rest) then begin
       SetLength(Results,high(Results)+2);
       SetLength(ResultsV,high(ResultsV)+2);
       Results[high(ResultsV)]  := t_ignore;
	    ResultsV[high(ResultsV)] := r.Match [0];
	end;
             
	besttoken := 0;
	maxlength := 0;
	result.token := besttoken;
	for i := 0 to high(Results) do begin
		if (length(ResultsV[i]) > maxlength) then begin
			maxlength := length(ResultsV[i]);
			besttoken := Results[i];
         	        result.token := besttoken;
                  	if (besttoken <> 0) then
	                result.val   := ResultsV[i];
		end;
	end;
   r.free;
end;

function Scanner (Input : String) : boolean;
var lasttoken : AToken;
begin
	result := false;
   if (length(Input) = 0) then begin result := true; exit; end;
	while (1=1) do begin
		lasttoken := FindToken(Input);
		if (lasttoken.token = 0) then break;
		if (lasttoken.token <> t_ignore) then begin
		  SetLength(TokenList,high(TokenList)+2); TokenList[high(TokenList)] := lasttoken; end;
		if (length(Input) > length(lasttoken.val)) then
		 delete(Input,1,length(lasttoken.val)) else begin result := true; exit; end;
	end;
   Writeln(Input);
	Writeln('');
	Writeln('No matching token found!');
end;




var
yylexpos : Integer = -1;
yylval   : string = '';

function yylex () : integer;
begin
  inc(yylexpos);
  result := 0;
  if(yylexpos > high(TokenList)) then begin yylval := ''; exit; end;
  yylval := TokenList[yylexpos].val;
  result := TokenList[yylexpos].token;
end;

const yymaxdepth = 10240;

function yyparse : Integer;


var yystate, yysp, yyn    : Integer;
    yys : array [1..yymaxdepth] of Integer;
    yyv : array [1..yymaxdepth] of String;
    yyval : String;

yychar   : Integer; (* current lookahead character *)

yydebug  : Boolean; (* set to true to enable debugging output of parser *)

yyflag    : ( yyfnone, yyfaccept, yyfabort, yyferror );
yyerrflag : Integer;


procedure yyerror ( msg : String );
  begin
    writeln(msg);
  end(*yyerrmsg*);

procedure yyclearin;
  begin
    yychar := -1;
  end(*yyclearin*);

procedure yyaccept;
  begin
    yyflag := yyfaccept;
  end(*yyaccept*);

procedure yyabort;
  begin
    yyflag := yyfabort;
  end(*yyabort*);

procedure yyerrlab;
  begin
    yyflag := yyferror;
  end(*yyerrlab*);

procedure yyerrok;
  begin
    yyerrflag := 0;
  end(*yyerrork*);


procedure yyaction ( yyruleno : Integer );
  (* local definitions: *)
begin
  (* actions: *)
  case yyruleno of
   1 : begin
         yyval := '<?xml version="1.0" ?>'+#13#10;
         yyval := yyval + '<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 20010904//EN" "http://www.w3.org/TR/2001/REC-SVG-20010904/DTD/svg10.dtd">'+#13#10;
         yyval := yyval +  '<svg width="1200" height="100" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink">'+#13#10;
         yyval := yyval +  ' <rect x="0" y="0" width="1200" height="100" fill="lightyellow" />'+#13#10;
         yyval := yyval +  '   <line x1="0" y1="30" x2="1200" y2="30" style="stroke:black;stroke-width:2"/>'+#13#10;
         yyval := yyval +  '   <line x1="0" y1="40" x2="1200" y2="40" style="stroke:black;stroke-width:2"/>'+#13#10;
         yyval := yyval +  '   <line x1="0" y1="50" x2="1200" y2="50" style="stroke:black;stroke-width:2"/>'+#13#10;
         yyval := yyval +  '   <line x1="0" y1="60" x2="1200" y2="60" style="stroke:black;stroke-width:2"/>'+#13#10;
         yyval := yyval +  '   <line x1="0" y1="70" x2="1200" y2="70" style="stroke:black;stroke-width:2"/>'+#13#10;
         
         yyval := yyval +  yyv[yysp-0]+#13#10;  
         
         yyval := yyval +  '</svg>';
         
         Output.WriteLine(yyval);
         
       end;
   2 : begin
         yyval := yyv[yysp-1]+yyv[yysp-0];
         
       end;
   3 : begin
         
       end;
   4 : begin
         cy := 0;
         
         if (yyv[yysp-2] = 'C0') then cy := 80;  if (yyv[yysp-2] = 'C1') then cy := 45;
         if (yyv[yysp-2] = 'D0') then cy := 75;  if (yyv[yysp-2] = 'D1') then cy := 40;
         if (yyv[yysp-2] = 'E0') then cy := 70;  if (yyv[yysp-2] = 'E1') then cy := 35;
         if (yyv[yysp-2] = 'F0') then cy := 65;  if (yyv[yysp-2] = 'F1') then cy := 30;
         if (yyv[yysp-2] = 'G0') then cy := 60;  if (yyv[yysp-2] = 'G1') then cy := 25;
         if (yyv[yysp-2] = 'A0') then cy := 55;  if (yyv[yysp-2] = 'A1') then cy := 20;
         if (yyv[yysp-2] = 'H0') then cy := 50;  if (yyv[yysp-2] = 'H1') then cy := 15;
         
         yyval := '<ellipse cx="' +InttoStr(x)+ '" cy="'+InttoStr(cy)+'" rx="8" ry="5" style="fill:black;"/>';
         
         if (yyv[yysp-0] = '2')or(yyv[yysp-0] = '4')or(yyv[yysp-0] = '8') then
         yyval := yyval + '<line x1="'+InttoStr(x+8)+'" y1="' + InttoStr(cy) +'" x2="'+InttoStr(x+8)+'" y2="'+ InttoStr(cy-30)+'" style="stroke:black;stroke-width:2" />'; 
         
         if (yyv[yysp-0] = '1')or(yyv[yysp-0] = '2')then   
         yyval := yyval + '<ellipse cx="' +InttoStr(x)+ '" cy="'+InttoStr(cy)+'" rx="3" ry="4" style="fill:white;"/>'; 
         
         if (yyv[yysp-0] = '8') then
         yyval := yyval + '<path d="M '+InttoStr(x+8)+',' + InttoStr(cy-30) +' q 0,10 5,10 t 5,10" style="stroke:black;" />'; 
         
         x := x + 40;
         
       end;
   5 : begin
         
       end;
   6 : begin
         
       end;
   7 : begin
         
       end;
   8 : begin
         
       end;
   9 : begin
         yyval := yyv[yysp-1] + yyv[yysp-0];
         
       end;
  10 : begin
         yyval := yyv[yysp-1] + yyv[yysp-0];
         
       end;
  11 : begin
         
       end;
  12 : begin
         
       end;
  13 : begin
         
       end;
  14 : begin
         
       end;
  15 : begin
         
       end;
  16 : begin
         
       end;
  17 : begin
         
       end;
  end;
end(*yyaction*);

(* parse table: *)

type YYARec = record
                sym, act : Integer;
              end;
     YYRRec = record
                len, sym : Integer;
              end;

const

yynacts   = 23;
yyngotos  = 10;
yynstates = 22;
yynrules  = 17;

yya : array [1..yynacts] of YYARec = (
{ 0: }
  ( sym: 265; act: 6 ),
  ( sym: 266; act: 7 ),
  ( sym: 267; act: 8 ),
  ( sym: 268; act: 9 ),
  ( sym: 269; act: 10 ),
  ( sym: 270; act: 11 ),
  ( sym: 271; act: 12 ),
{ 1: }
  ( sym: 261; act: 13 ),
  ( sym: 264; act: 14 ),
{ 2: }
  ( sym: 257; act: 15 ),
{ 3: }
  ( sym: 265; act: 6 ),
  ( sym: 266; act: 7 ),
  ( sym: 267; act: 8 ),
  ( sym: 268; act: 9 ),
  ( sym: 269; act: 10 ),
  ( sym: 270; act: 11 ),
  ( sym: 271; act: 12 ),
  ( sym: 0; act: -3 ),
{ 4: }
{ 5: }
  ( sym: 0; act: 0 ),
{ 6: }
{ 7: }
{ 8: }
{ 9: }
{ 10: }
{ 11: }
{ 12: }
{ 13: }
{ 14: }
{ 15: }
  ( sym: 258; act: 18 ),
  ( sym: 261; act: 19 ),
  ( sym: 262; act: 20 ),
  ( sym: 263; act: 21 )
{ 16: }
{ 17: }
{ 18: }
{ 19: }
{ 20: }
{ 21: }
);

yyg : array [1..yyngotos] of YYARec = (
{ 0: }
  ( sym: -7; act: 1 ),
  ( sym: -5; act: 2 ),
  ( sym: -4; act: 3 ),
  ( sym: -3; act: 4 ),
  ( sym: -2; act: 5 ),
{ 1: }
{ 2: }
{ 3: }
  ( sym: -7; act: 1 ),
  ( sym: -5; act: 2 ),
  ( sym: -4; act: 3 ),
  ( sym: -3; act: 16 ),
{ 4: }
{ 5: }
{ 6: }
{ 7: }
{ 8: }
{ 9: }
{ 10: }
{ 11: }
{ 12: }
{ 13: }
{ 14: }
{ 15: }
  ( sym: -6; act: 17 )
{ 16: }
{ 17: }
{ 18: }
{ 19: }
{ 20: }
{ 21: }
);

yyd : array [0..yynstates-1] of Integer = (
{ 0: } 0,
{ 1: } 0,
{ 2: } 0,
{ 3: } 0,
{ 4: } -1,
{ 5: } 0,
{ 6: } -11,
{ 7: } -12,
{ 8: } -13,
{ 9: } -14,
{ 10: } -15,
{ 11: } -16,
{ 12: } -17,
{ 13: } -9,
{ 14: } -10,
{ 15: } 0,
{ 16: } -2,
{ 17: } -4,
{ 18: } -5,
{ 19: } -8,
{ 20: } -6,
{ 21: } -7
);

yyal : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 8,
{ 2: } 10,
{ 3: } 11,
{ 4: } 19,
{ 5: } 19,
{ 6: } 20,
{ 7: } 20,
{ 8: } 20,
{ 9: } 20,
{ 10: } 20,
{ 11: } 20,
{ 12: } 20,
{ 13: } 20,
{ 14: } 20,
{ 15: } 20,
{ 16: } 24,
{ 17: } 24,
{ 18: } 24,
{ 19: } 24,
{ 20: } 24,
{ 21: } 24
);

yyah : array [0..yynstates-1] of Integer = (
{ 0: } 7,
{ 1: } 9,
{ 2: } 10,
{ 3: } 18,
{ 4: } 18,
{ 5: } 19,
{ 6: } 19,
{ 7: } 19,
{ 8: } 19,
{ 9: } 19,
{ 10: } 19,
{ 11: } 19,
{ 12: } 19,
{ 13: } 19,
{ 14: } 19,
{ 15: } 23,
{ 16: } 23,
{ 17: } 23,
{ 18: } 23,
{ 19: } 23,
{ 20: } 23,
{ 21: } 23
);

yygl : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 6,
{ 2: } 6,
{ 3: } 6,
{ 4: } 10,
{ 5: } 10,
{ 6: } 10,
{ 7: } 10,
{ 8: } 10,
{ 9: } 10,
{ 10: } 10,
{ 11: } 10,
{ 12: } 10,
{ 13: } 10,
{ 14: } 10,
{ 15: } 10,
{ 16: } 11,
{ 17: } 11,
{ 18: } 11,
{ 19: } 11,
{ 20: } 11,
{ 21: } 11
);

yygh : array [0..yynstates-1] of Integer = (
{ 0: } 5,
{ 1: } 5,
{ 2: } 5,
{ 3: } 9,
{ 4: } 9,
{ 5: } 9,
{ 6: } 9,
{ 7: } 9,
{ 8: } 9,
{ 9: } 9,
{ 10: } 9,
{ 11: } 9,
{ 12: } 9,
{ 13: } 9,
{ 14: } 9,
{ 15: } 10,
{ 16: } 10,
{ 17: } 10,
{ 18: } 10,
{ 19: } 10,
{ 20: } 10,
{ 21: } 10
);

yyr : array [1..yynrules] of YYRRec = (
{ 1: } ( len: 1; sym: -2 ),
{ 2: } ( len: 2; sym: -3 ),
{ 3: } ( len: 1; sym: -3 ),
{ 4: } ( len: 3; sym: -4 ),
{ 5: } ( len: 1; sym: -6 ),
{ 6: } ( len: 1; sym: -6 ),
{ 7: } ( len: 1; sym: -6 ),
{ 8: } ( len: 1; sym: -6 ),
{ 9: } ( len: 2; sym: -5 ),
{ 10: } ( len: 2; sym: -5 ),
{ 11: } ( len: 1; sym: -7 ),
{ 12: } ( len: 1; sym: -7 ),
{ 13: } ( len: 1; sym: -7 ),
{ 14: } ( len: 1; sym: -7 ),
{ 15: } ( len: 1; sym: -7 ),
{ 16: } ( len: 1; sym: -7 ),
{ 17: } ( len: 1; sym: -7 )
);


const _error = 256; (* error token *)

function yyact(state, sym : Integer; var act : Integer) : Boolean;
  (* search action table *)
  var k : Integer;
  begin
    k := yyal[state];
    while (k<=yyah[state]) and (yya[k].sym<>sym) do inc(k);
    if k>yyah[state] then
      yyact := false
    else
      begin
        act := yya[k].act;
        yyact := true;
      end;
  end(*yyact*);

function yygoto(state, sym : Integer; var nstate : Integer) : Boolean;
  (* search goto table *)
  var k : Integer;
  begin
    k := yygl[state];
    while (k<=yygh[state]) and (yyg[k].sym<>sym) do inc(k);
    if k>yygh[state] then
      yygoto := false
    else
      begin
        nstate := yyg[k].act;
        yygoto := true;
      end;
  end(*yygoto*);

label parse, next, error, errlab, shift, reduce, accept, abort;

begin(*yyparse*)

  (* initialize: *)

  yystate := 0; yychar := -1; yyerrflag := 0; yysp := 0;

{$ifdef yydebug}
  yydebug := true;
{$else}
  yydebug := false;
{$endif}

parse:

  (* push state and value: *)

  inc(yysp);
  if yysp>yymaxdepth then
    begin
      yyerror('yyparse stack overflow');
      goto abort;
    end;
  yys[yysp] := yystate; yyv[yysp] := yyval;

next:

  if (yyd[yystate]=0) and (yychar=-1) then
    (* get next symbol *)
    begin
      yychar := yylex; if yychar<0 then yychar := 0;
    end;

  if yydebug then writeln('state ', yystate, ', char ', yychar);

  (* determine parse action: *)

  yyn := yyd[yystate];
  if yyn<>0 then goto reduce; (* simple state *)

  (* no default action; search parse table *)

  if not yyact(yystate, yychar, yyn) then goto error
  else if yyn>0 then                      goto shift
  else if yyn<0 then                      goto reduce
  else                                    goto accept;

error:

  (* error; start error recovery: *)

  if yyerrflag=0 then yyerror('syntax error');

errlab:

  if yyerrflag<=2 then                  (* incomplete recovery; try again *)
    begin
      yyerrflag := 3;
      (* uncover a state with shift action on error token *)
      while (yysp>0) and not ( yyact(yys[yysp], _error, yyn) and
                               (yyn>0) ) do
        begin
          if yydebug then
            if yysp>1 then
              writeln('error recovery pops state ', yys[yysp], ', uncovers ',
                      yys[yysp-1])
            else
              writeln('error recovery fails ... abort');
          dec(yysp);
        end;
      if yysp=0 then goto abort; (* parser has fallen from stack; abort *)
      yystate := yyn;            (* simulate shift on error *)
      goto parse;
    end
  else                                  (* no shift yet; discard symbol *)
    begin
      if yydebug then writeln('error recovery discards char ', yychar);
      if yychar=0 then goto abort; (* end of input; abort *)
      yychar := -1; goto next;     (* clear lookahead char and try again *)
    end;

shift:

  (* go to new state, clear lookahead character: *)

  yystate := yyn; yychar := -1; yyval := yylval;
  if yyerrflag>0 then dec(yyerrflag);

  goto parse;

reduce:

  (* execute action, pop rule from stack, and go to next state: *)

  if yydebug then writeln('reduce ', -yyn);

  yyflag := yyfnone; yyaction(-yyn);
  dec(yysp, yyr[-yyn].len);
  if yygoto(yys[yysp], yyr[-yyn].sym, yyn) then yystate := yyn;

  (* handle action calls to yyaccept, yyabort and yyerror: *)

  case yyflag of
    yyfaccept : goto accept;
    yyfabort  : goto abort;
    yyferror  : goto errlab;
  end;

  goto parse;

accept:

  yyparse := 0; exit;

abort:

  yyparse := 1; exit;

end(*yyparse*);


var ShowTokens : boolean = false;
    InputFilename : String = '';
    OutputFilename : String = ''; 
    iterationVar : Integer; SL : TStringList; inputstream,outputstream  : string ;
begin
try 
 for iterationVar := 1 to ParamCount do begin
  if lowercase(ParamStr(iterationVar)) =  '-t' then ShowTokens := true else
  if (InputFilename = '') then InputFilename := ParamStr(iterationVar) else
  if (OutputFilename = '') then OutputFilename := ParamStr(iterationVar) else begin
   Writeln('Too many argument!');
   ExitCode := 1;
   exit;
  end;
 end;
 if (InputFilename = '') then begin
   Writeln('You need to specify input and outputfile: compiler.exe input.txt output.txt');
   ExitCode := 1;
   exit;
 end;
 SL := TStringList.Create();
 SL.LoadFromFile(InputFilename);
 inputstream := SL.Text;
 SL.Free;
 outputstream := '';


 if not Scanner(inputstream) then begin
  ExitCode := 1;
  exit;
 end;

 if (ShowTokens) then begin
  for iterationVar := 0 to high(TokenList) do 
   WriteLn('TokenID: ',TokenList[iterationVar].token,'  =  '+TokenList[iterationVar].val);
 end;

 Output := TOutput.Create();

 if yyparse() <> 0 then begin
  ExitCode := 1;
  exit;
 end;

 outputstream := Output.Text;

 if (OutputFilename <> '') then begin
  SL := TStringList.Create();
  SL.SetText(pchar(outputstream));
  SL.SaveToFile(OutputFilename);
  SL.Free;
 end else 
  Writeln(outputstream);
Except
end;
 ExitCode := 0;
end.

